{
        This Code Was Created By Jan Koci 2002
        Visit My Site At http://koci.opengl.cz
}

// Unita, ktera vykresluje objekty

unit KDrawObjects;

interface

uses OpenGL;


procedure DrawCube;    //vykreslovani trojuhelniku

implementation

uses KTextures, KTypes, KLoadObjects, KTime;

var
  angle: TPoint3d;    //uhel rotace objektu
  translate: TPoint3d;    //pozice objektu
  direction: TPoint3d;    //smer pohybu objektu
  start: boolean=true;    //pomocna promenna pro nacitani zakladnich hodnot pri startu aplikace


procedure TranRotCube;
begin
    //zacatek vypoctu pohybu objektu
    if (start) then     //jestlize probiha prvni otocka cyklu
    begin
      direction.x := 1;    //nastav smer pohybu objektu v X smeru na 1
      direction.y := 1;    //nastav smer pohybu objektu v Y smeru na 1
      direction.z := 1;    //nastav smer pohybu objektu v Z smeru na 1
      translate.z := -8;   //nastav Z pozici objektu
      start := false;    //nastav start na false, aby pri dalsi otocce cyklu se zakladni hodnoty nenacitaly
    end;

    if ((translate.x >= 3) or (translate.x <= -3)) then  //jetlize X pozice objektu presahne hodnoty 3 nebo -3
    begin
        direction.x := -direction.x;    //otoc smer pohybu X
    end;
    translate.x := translate.x + (0.01 * direction.x * step);    //pricti 0.01 pozici X, podle smeru pohybu X a velikosti kroku

    if ((translate.y >= 2) or (translate.y <= -2)) then    //jetlize Y pozice objektu presahne hodnoty 2 nebo -2
    begin
        direction.y := -direction.y;    //otoc smer pohybu Y
    end;
    translate.y := translate.y + (0.01 * direction.y * step);    //pricti 0.01 pozici Y, podle smeru pohybu Y a velikosti kroku

    if ((translate.z >= -6) or (translate.z <= -20)) then    //jetlize Z pozice objektu presahne hodnoty -6 nebo -20
    begin
        direction.z := -direction.z;    //otoc smer pohybu Z
    end;
    translate.z := translate.z + (0.01 * direction.z * step);    //pricti 0.01 pozici Z, podle smeru pohybu Z a velikosti kroku
    //konec vypoctu pohubu objektu

    //zacatek vypoctu rotace objektu
    angle.x := angle.x + (0.5 * step);    //pricti 0.5 uhlu X rotace podle velikosti kroku
    if (angle.x >= 360) then    //jestlize je uhel vetsi, nez 360 stupnu
    begin
      angle.x := angle.x -360;    //odecti 360 stupnu
    end;

    angle.y := angle.y + (1 * step);    //pricti 1 uhlu Y rotace podle velikosti kroku
    if (angle.y >= 360) then    //jestlize je uhel vetsi, nez 360 stupnu
    begin
      angle.y := angle.y -360;    //odecti 360 stupnu
    end;

    angle.z := angle.z + (1.5 * step);    //pricti 1.5 uhlu Z rotace podle velikosti kroku
    if (angle.z >= 360) then    //jestlize je uhel vetsi, nez 360 stupnu
    begin
      angle.z := angle.z -360;    //odecti 360 stupnu
    end;
    //konec vypoctu rotace objektu
end;

procedure DrawCube;    //vykresli krychli
begin
    TranRotCube;    //vypocitej pohyb a rotaci krychle

    //zacatek bloku OpenGL prikazu pro vykresleni objektu (krychle)
    glEnable(GL_TEXTURE_2D);    //zapni 2D texturovani
    glBindTexture(GL_TEXTURE_2D, Texture[0]);    //potahni nasledujici objekt texturou cislo 0
    glPushMatrix;    //zacatek prostorove matice

    //posouvej a rotuj objektem (ktery je mezi glPushMatrix; a glPopMatrix;) podle vypoctenych hodnot
    glTranslatef( translate.x, translate.y, translate.z);    //pohni celym objektem
    glRotatef( angle.x, 1, 0, 0);    //rotuj objektem v X smeru
    glRotatef( angle.y, 0, 1, 0);    //rotuj objektem v Y smeru
    glRotatef( angle.z, 0, 0, 1);    //rotuj objektem v Z smeru

    glBegin(GL_TRIANGLES);    //zacni vykreslovat trojuhelniky

      //------------------------

      //predni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //prava stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //zadni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //leva stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //vrchni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[1].x, cube1.points[1].y, cube1.points[1].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[5].x, cube1.points[5].y, cube1.points[5].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[3].x, cube1.points[3].y, cube1.points[3].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[7].x, cube1.points[7].y, cube1.points[7].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------

      //spodni stena krychle
      //prvni trojuhelnik
      glTexCoord2f( 0, 0);  glVertex3f( cube1.points[6].x, cube1.points[6].y, cube1.points[6].z);    //levy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //levy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce

      //druhy trojuhelnik
      glTexCoord2f( 1, 1);  glVertex3f( cube1.points[2].x, cube1.points[2].y, cube1.points[2].z);    //pravy horni vrchol textury a vysledneho ctverce
      glTexCoord2f( 1, 0);  glVertex3f( cube1.points[4].x, cube1.points[4].y, cube1.points[4].z);    //pravy dolni vrchol textury a vysledneho ctverce
      glTexCoord2f( 0, 1);  glVertex3f( cube1.points[0].x, cube1.points[0].y, cube1.points[0].z);    //levy horni vrchol textury a vysledneho ctverce

      //-------------------------


    glEnd();  //ukonci vykreslovani trojuhelniku
    glPopMatrix;    //konec prostorove matice
    //konec bloku OpenGL prikazu pro vykresleni objektu (krychle)
end;



end.
